<?php
namespace ServerHelper;

class Settings
{

    /* settings.json
     * SERVER
     * Local : Server
     * Base : Server
     * Sync : Cloud
     * SyncMaster : Cloud Master
     * Server : Cloud
     * ServerMaster : Cloud Master
     *
     *
     * Counter
     * Local : Counter
     * Base : Server
     * Sync : Server
     * SyncMaster : Server
     * Server : Cloud
     * ServerMaster : Cloud Master
     * */

    public $LocalDatabase;
    public $LocalMasterDatabase;
    public $SyncDatabase;
    public $SyncMasterDatabase;
    public $ServerDatabase;
    public $ServerMasterDatabase;
    public $BaseDatabase;
    public $BaseMasterDatabase;
    public $BackupDatabase;
    public $BackupMasterDatabase;
    public $BranchId;
    public $LanIpAddress;
    public $RemoteHost = "www.google.com";

    public function __construct()
    {
        $data = json_decode(file_get_contents(__DIR__ . "/settings.json"),true);

        $this->LocalDatabase = (object)$data['LocalDatabase'];
        $this->BaseDatabase = (object)$data['BaseDatabase'];
        $this->SyncDatabase = (object)$data['SyncDatabase'];
        $this->SyncMasterDatabase = (object)$data['SyncMasterDatabase'];
        $this->ServerDatabase = (object)$data['ServerDatabase'];
        $this->ServerMasterDatabase = (object)$data['ServerMasterDatabase'];

        $this->LocalMasterDatabase = $this->LocalDatabase;
        $this->BaseMasterDatabase = $this->BaseDatabase;
        $this->BackupDatabase = $this->LocalDatabase;
        $this->BackupMasterDatabase = $this->LocalMasterDatabase;

        $this->BranchId = $data['BranchId'];
        $this->LanIpAddress = $data['LanIpAddress'];

    }

    public function GetStoredValue($key, $def = "")
    {
        $data = json_decode(file_get_contents(__DIR__ . "/storage.json"),true);
        if(isset($data[$key])) {
            return $data[$key];
        }
        return $def;

    }
    public function SetStoredValue($key, $value)
    {
        $data = json_decode(file_get_contents(__DIR__ . "/storage.json"), true);

        $data[$key] = $value;

        file_put_contents(__DIR__ . "/storage.json", json_encode($data));

    }
	
	public function ping($host, $port=80, $timeout=1)
	{
		$fsock = @fsockopen($host, $port, $errno, $errstr, $timeout);
		if ( $fsock ) {
			fclose($fsock);
			return true;
		}
		else {
			return false;
		}
	}

    public function IsHostAccessible()
    {
		return $this->ping($this->RemoteHost);
    }

    public function Log($data, $type = "log")
    {

    }

    public function SetConnection($conn)
    {

        $this->SetStoredValue('conn', $conn);

    }

    public function GetConnection($def = "")
    {

        return $this->GetStoredValue('conn', $def);

    }

    public function StartSync()
    {
        $wd = getcwd();
        chdir(__DIR__ . '/sync');
        system("cmd /c ".__DIR__ . "/sync/cron.bat");
        chdir($wd);
    }



}