class cSharp {
	constructor() {
		this.setKeyEvent();
		this.fullscreen = false;
		this.lan_url = '';
	}
	
	init()  {
		var _this = this;

		$.ajaxSetup({
            complete: function(request, textStatus){
				var conn = request.getResponseHeader('x-db-connection');
				setConnection(conn);
			}
		});
	}

	bind() {
		this.init();
    }
	
	

	setKeyEvent() {
		var $this = this;

		$(document).keydown(function(e) {
			if (e.keyCode == 70 && e.ctrlKey) {
				

				e.stopPropagation();
				e.preventDefault();

				window.phpdesktop.ToggleFullscreen();
			}

			if (e.keyCode == 69 && e.ctrlKey) {

				e.stopPropagation();
				e.preventDefault();

				window.close();
			}
			
			// Key: Y; Action: Server Sync
			if (e.keyCode == 89 && e.ctrlKey) {
				
				e.stopPropagation();
				e.preventDefault();
				
				$this.syncServer();
			}
			
			// Key: U; Action: Cloud Sync
			if (e.keyCode == 85 && e.ctrlKey) {
				
				e.stopPropagation();
				e.preventDefault();
				
				$this.syncCloud();
            }

            // Key: H; Action: Network Check 
            if (e.keyCode == 72 && e.ctrlKey) {

                e.stopPropagation();
                e.preventDefault();

                $this.checkConnection();
            }
		});
	}

	loadPOS() {
		this.loadCompany();
		this.setUser(this.getUser());
	}

	setCompany(company, settings) {
		$('.yl_company_name').html(company.name);
		$('.yl_company_address').html(company.address + ',' + company.city + '-' + company.pincode + ',' + company.state);

		Template7.global = {
			company: company,
			settings: settings
		};
	}

	getCompany() {
		var cmp = localStorage.getItem('company');
		if (cmp) return JSON.parse(cmp);
		return null;
	}

	loadCompany() {
		var _this = this;
		var cmp = localStorage.getItem('company');
		var settings = localStorage.getItem('settings');
		if (cmp) { _this.setCompany(JSON.parse(cmp), JSON.parse(settings)); return};

		$.get('DataResponse.php?req=company', {}, function(data) {
			if(data['success']) {
				localStorage.setItem('company', JSON.stringify(data['company']));
				localStorage.setItem('settings', JSON.stringify(data['settings']));
				_this.setCompany(data['company'], data['settings']);
			}
		});
	}

	setUser(user) {
		$('input[name="branchid"]').val(user.branch);
		$('input[name="operator"]').val(user.name);
		$('.yl_user_name').html(user.name);
	}

	getUser() {
		var user = localStorage.getItem('user');
		if (user) return JSON.parse(user);
		return null;
	}

	checkConnection() {
		$.get('DataResponse2.php?req=check_server');
	}

	syncServer() {
		$.get('DataResponse2.php?req=sync');
	}

	syncCloud() {
		$.get(this.lan_url + 'DataResponse2.php?req=sync');
	}

	setCookie(cname, cvalue, exdays=365) {
  	    var d = new Date();
  	    d.setYear(d.getFullYear() + exdays);
  	    var expires = "expires="+ d.toUTCString();
  	    document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
  	}
	
	print(parent) {
		let $this = this;
		return function(div, flag = false, data = false) {
			let div_dom = document.getElementById(div);

			if (!div_dom) {
				console.log('no print');
				return;
			}

			if (flag) {
				$this.requestPrint(div_dom.innerHTML, ['assets/css/style-shift.css']);

				div_dom.style.display = 'none';

				if (parent) {
					parent.InsertShiftClose(data);
				}
			}
			else{
				$this.requestPrint(div_dom.innerHTML, ['assets/css/print_pos.css']);

				div_dom.style.display = 'none';
				location.reload(); 
			}
		}
	}
	
	requestPrint(html, css) {
		$.post('print.php', {html: html, css: css});
	}
}

var c_sharp = new cSharp();
c_sharp.bind();

function setConnection(conn) {
	var el = document.querySelector(".cef_sharp_connection");

	if (!el) return;

	if (conn === 'default') {
		el.classList.add("default");
		el.classList.remove("backup");
	}
	else {
		el.classList.add("backup");
		el.classList.remove("default");
	}
}

$(document).on('click', '.c_sharp_server_sync', function(e) {
	e.preventDefault();

	c_sharp.syncServer();
});

$(document).on('click', '.c_sharp_cloud_sync', function(e) {
	e.preventDefault();
	
	c_sharp.syncCloud();
});

$(document).on('click', '.cef_sharp_connection', function(e) {
	e.preventDefault();
	
	c_sharp.checkConnection();
});
