<?php
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
if(isset($_GET['get']) && $_GET['get'] === 'change_ip') {
    $server_ip = $_GET['server_ip'];
    $action = $_GET['action'] ?? 'server';


    $error = 1;
    $message = 'Ip Not Change';
    if($server_ip) {
        $data = json_decode(file_get_contents(__DIR__ . "/settings.json"),true);
        $data['LanIpAddress'] = 'http://'.$server_ip.'/AccPos/';
        if($action === 'counter') {
            $data['BaseDatabase']['HostName'] = $server_ip;
            $data['SyncDatabase']['HostName'] = $server_ip;
            $data['SyncMasterDatabase']['HostName'] = $server_ip;
        }

        file_put_contents(__DIR__ . "/settings.json", json_encode($data,JSON_UNESCAPED_SLASHES));
        $error = 0;
        $message = 'Ip Changed Successfully';
    }

    echo json_encode(['err' => $error, 'msg' => $message]);
    exit();
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <link rel="shortcut icon" type="image/png" href="assets/images/favicon.ico">
    <meta charset="UTF-8">
    <title>Ip</title>
    <link rel="stylesheet" type="text/css" href="assets/css/bootstrap.min.css">
</head>
<body>
<form class="justify-content-center align-items-center container">

    <div class='row'>
        <div class="offset-md-3 col-md-4">
            <div class="form-group">
                <label>Server Ip</label>
                <input type="text" class="form-control" placeholder="Server Ip" name="ip_address">
            </div>
        </div>
    </div>
    <div class="row">
        <div class="offset-md-3 col-md-6">
            <button type="button" class="btn btn-success" id="save_btn" name="change_ip"><i class="icon-save"></i> Save
            </button>
        </div>
    </div>
</form>
<script type="text/javascript" src="assets/js/jquery-3.2.1.min.js"></script>


<script>
    $.getJSON('settings.json', function(data) {
        let pos_url = data.LanIpAddress;
        let server_ip = pos_url.split('/')[2];
        $('input[name="ip_address"]').val(server_ip);
    });

    $(document).on('click', 'button[name="change_ip"]', function(e){
        e.preventDefault();
        let server_ip_address =  $('input[name="ip_address"]').val();
        if(!$.trim(server_ip_address)) {
            alert('Please Enter Ip Address ...... ');
            return false;
        }
        let ip = "^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$";
        if(!server_ip_address.match(ip)) {
            alert('Please Enter Valid Ip Address ...... ');
            return false;
        }

        $.get('change-ip.php', {server_ip : server_ip_address, get : 'change_ip'}, function(data) {
            let data_result = $.parseJSON(data);
            alert(data_result['msg']);
            if(data_result['err'])
                location.reload();
        });
    });
</script>
<!--edit-->
</body>
</html>