<?php 
/**
* 
*
*Class For App
*
**/
date_default_timezone_set("Asia/Kolkata");
class ClassApp 
{
 	public $db;
 	public $currentDB = [];
 	public $alterDB = [];
 	function __construct($db)
 	{
 		$this->db = $db;
 	}
 	public function searchForId($id, $array , $except) {
	   foreach ($array as $key => $val) {
	
	       if ($val->id == $id && $key != $except) {
	           return  array('key' => $key );
	       }
	   }
	   return false;
	}
 	public function getProductByCode($code){
        $item_code = "ItemCode";
        if(strlen($code) > 10) $item_code = "BarCodeId";

        $query = $this->db->query("SELECT isWeighingScaleRead as weighingscale ,ItemCode as code, ItemId as id, ItemName as name, SellingPrice as price ,PurchaseUnit as unit ,isBatchExpiry as ratewise ,isnegativestockallowed as negAllow ,taxstrucode as taxcode ,(SELECT taxrate FROM tbltaxstru WHERE taxstrucode = taxcode) as tax , (SELECT cessrate FROM tbltaxstru WHERE taxstrucode = taxcode) as cesstax from tblitemmaster where ItemCode = ? AND ItemType != 'Whole Sale'", [$code]);
        if (!($query && $query->num_rows)) {
            $query = $this->db->query("SELECT ItemCode as code, ItemId as id, ItemName as name, SellingPrice as price ,PurchaseUnit as unit ,isBatchExpiry as ratewise ,isnegativestockallowed as negAllow ,taxstrucode as taxcode ,(SELECT taxrate FROM tbltaxstru WHERE taxstrucode = taxcode) as tax , (SELECT cessrate FROM tbltaxstru WHERE taxstrucode = taxcode) as cesstax from tblitemmaster where BarCodeId = ? AND ItemType != 'Whole Sale'", [$code]);
            if (!($query && $query->num_rows)) {
                echo json_encode(['success' => false, 'reason' => 'Item Not Found', 'details' => []]);
                exit();
            }
        }

        $item = $query->fetchArray();
        $item['similar'] = $query->fetchArray();

        if ((int)$item['ratewise']) {

            $negAllow = $item['negAllow'] ? '':' AND qtybalance > 0 ';

            $query1 = $this->db->query("SELECT saleprice,qtybalance,Mrp from tblstockdetails where ItemCode = ? ".$negAllow." AND status='A'", [$code]);

            if ($query1 && $query1->num_rows) {

                $item['stockdetails'] = $query1->fetchAllArray();

            }

        }

        echo json_encode(['success' => true, 'reason' => 'Details Found', 'details' => $item]);
    }
 	public function getProductList($num,$name){
 		$perpage = 30;
 		$start = ($num-1)*$perpage;
 		$where = !empty($name) ? 'WHERE ItemName LIKE "'.$name.'%" OR ItemCode LIKE "'.$name.'%"': ' ' ;
 		$sql = "SELECT ItemCode as code, ItemId as id, ItemName as name, SellingPrice as price ,PurchaseUnit as unit ,taxstrucode as tax from tblitemmaster ".$where;
 		$where1 = !empty($name) ? 'WHERE ItemName LIKE "%'.$name.'%" OR ItemCode LIKE "%'.$name.'%"': ' ' ;
 		$sql1 = "SELECT ItemCode as code, ItemId as id, ItemName as name, SellingPrice as price ,PurchaseUnit as unit ,taxstrucode as tax from tblitemmaster ".$where1;
 		$query = $this->db->query($sql.' UNION '. $sql1." limit " . $start . "," . $perpage);
 		if ($query && $query->num_rows) {
	        $item = $query->fetchAll();
	        echo json_encode(['success' => true, 'reason' => 'Details Found', 'details' => $item]);
	    }else{
            echo json_encode(['success' =>false,'reason' => 'Item Not Found', 'details' => [],'query'=>$sql."  Union ".$sql1]);
	    }
 	}
 	public function getPendingList($num,$name,$date,$counterno){
 		$perpage = 30;
 		$start = ($num-1)*$perpage;
 		$where = !empty($name) ? "AND CAST(BillNo as CHAR) LIKE '".$name."%'": " " ;
 		$sql = "SELECT * from tblpos WHERE counterno = $counterno AND InvDate = '".$date."' AND isPending = 1 ".$where." limit " . $start . "," . $perpage;
 		$where1 = !empty($name) ? "AND CAST(BillNo as CHAR) LIKE '%".$name."%'": " " ;
 		$sql1 = "SELECT * from tblpos WHERE counterno = $counterno  AND InvDate = '".$date."' AND isPending = 1 ".$where1." limit " . $start . "," . $perpage;
 		$query = $this->db->query($sql.' UNION '. $sql1);
 		if ($query && $query->num_rows) {
	        $item = $query->fetchAll();
	        echo json_encode(['success' => true, 'reason' => 'Details Found', 'details' => $item]);
	    }else{
            echo json_encode(['success' =>false,'reason' => 'Item Not Found', 'details' => []]);
	    }
 	}
    public function getUnsavedPos($counterno)
 	{
 		$sql = "SELECT * from tblposunsaved WHERE counterno = $counterno AND isPending = 1 ORDER BY posid DESC LIMIT 1";
 		$query = $this->db->query($sql);
 		if ($query && $query->num_rows) {
	        $item = $query->fetchObject();
	        $sql1 = "SELECT *,(SELECT ItemId from tblitemmaster WHERE ItemCode = details.ItemCode) as id ,(SELECT isWeighingScaleRead from tblitemmaster WHERE ItemCode = details.ItemCode) as weighingscale ,(SELECT isnegativestockallowed from tblitemmaster WHERE ItemCode = details.ItemCode) as negAllow ,(SELECT isBatchExpiry from tblitemmaster WHERE ItemCode = details.ItemCode) as ratewise ,( SELECT taxstrucode from tblitemmaster WHERE ItemCode = details.ItemCode ) as taxcode from tblposunsaveddetails as details WHERE postblid = $item->posid AND isdeleted = 0";
            $query1 = $this->db->query($sql1);
            if ($query1 && $query1->num_rows) {
	            $details = $query1->fetchAll();
	            foreach ($details as $key => $value) {
                    
		        	if ($value->ratewise) {

			        	$negAllow = $value->negAllow ? '':' AND qtybalance > 0 ';

				        $query1 = $this->db->query("SELECT saleprice,qtybalance,Mrp from tblstockdetails where ItemCode = ? ".$negAllow." AND status='A'", [$value->ItemCode]);

				        if ($query1 && $query1->num_rows) {
				        	

	          	            $search = $this->searchForId($value->id,$details,$key);

				        	if ($search) {
			          	    
			          	      $details[$search['key']]->id = 'cpy-'.$details[$search['key']]->id;
			          	      
			          	    }

			              	$details[$key]->stockdetails = $query1->fetchAllArray();

				        }
			        }
			        $frees = $this->db->query("SELECT tblid as id, qty, freeitemcode ,freeqty,freeused FROM tblfreeitems WHERE itemCode = ? AND (totalfreeqty - freeused ) > 0", [$value->ItemCode]);
                    if ($frees && $frees->num_rows) {

	                    $freeitem = $frees->fetchAllArray();
	                    $details[$key]->freeItems = $freeitem;
		            }
                }
	            echo json_encode(['success' => true, 'reason' => 'Details Found','bill'=>$item , 'details' => $details]);
	        }else{
               echo json_encode(['success' =>false,'reason' => 'Item Not Found' ,'bill'=>$item , 'details' => []]);
	        }
	    }else{
            echo json_encode(['success' =>false,'reason' => 'Item Not Found', 'details' => []]);
	    }
 	}
 	public function getPosDetails($posid){
      $sql = "SELECT *,(SELECT ItemId from tblitemmaster WHERE ItemCode = deatails.ItemCode) as id ,(SELECT isnegativestockallowed from tblitemmaster WHERE ItemCode = deatails.ItemCode) as negAllow ,(SELECT isBatchExpiry from tblitemmaster WHERE ItemCode = deatails.ItemCode) as ratewise ,( SELECT taxstrucode from tblitemmaster WHERE ItemCode = deatails.ItemCode ) as taxcode from tblposdetails as deatails WHERE postblid = $posid ";
      $query = $this->db->query($sql);
      if ($query && $query->num_rows) {
	        $item = $query->fetchAll();	        
	        echo json_encode(['success' => true, 'reason' => 'Details Found', 'details' => $item]);
	    } else {
            echo json_encode(['success' =>false,'reason' => 'Item Not Found', 'details' => []]);
	    }

	    // $this->deletePosDetail($posid);
	    // $this->deletePos($posid);

	    exit();
 	}
 	public function getCounterDiscount($counter){

      $query = $this->db->query("SELECT discountperc from tblcountersettings where counterid = ?", [$counter]);

       if ($query && $query->num_rows) {

	        $item = $query->fetchArray();

	        echo json_encode(['success' => true, 'reason' => 'Details Found', 'details' => $item]);

	    }else{

        echo json_encode(['success' => false, 'reason' => 'Item Not Found', 'details' => []]);

	    }
 	}
 	public function getFreeItems($code){

       $query = $this->db->query("SELECT tblid as id, qty, freeitemcode ,freeqty,freeused FROM tblfreeitems WHERE itemCode = ? AND (totalfreeqty - freeused ) > 0", [$code]);
       if ($query && $query->num_rows) {

	        $item = $query->fetchAllArray();

	        echo json_encode(['success' => true, 'reason' => 'Details Found', 'details' => $item]);

	    }else{

        echo json_encode(['success' => false, 'reason' => 'Item Not Found', 'details' => []]);

	    }
 	}
 	public function addpos($data ,$flag){
 		if (!$data['memberlocalstorage'] && isset($data['redeemed']) && $data['redeemed'] > 0) {
 			
 			if (!$this->processRedeem($data['phone'] , $data['redeemed'],$data['pointsearned'])) {
 				echo json_encode(['success'=>'false']);
 				return;
 			}
 		}
 		
 		if ($data['unsavedbill']) {
 		   $this->closeUnsavedpos($data['unsavedbill']);
 		}
 		$today = date("Y-m-d");
 		 
        if (!$data['posid']) {
	 		$sql = "INSERT into tblpos( BranchId , counterno , InvDate , BillNo, PartyCode ,Partyname,PartyAddress,PartyEmail,Total,discountperc,TotalDiscount,SGST,CGST,CESS,GrandTotal,RoundOff,BillAmount,PayType,paidamount,changeamount,pointsearned,pointsredeemed,noofbags,isPending,isdiscountapplied,CreatedBy) VALUES ( ".$data['branchid']." , ".$data['counter']." , '".$today."' , ".$data['billno']." ,'".$data['phone']."' , '".$data['partyname']."' , '".$data['phone']."' , '".$data['email']."' ,".$data['subTotal']." , ".$data['discperc']." , ".$data['disc']." , ".$data['sgst']." , ".$data['cgst']." , ".$data['cess']." , ".$data['grandTotal']." , ".$data['roundof']." , ".$data['netTotal']." , '".$data['paytype']."' , ".$data['cashreceived']." , ".$data['balance']." , ".$data['pointsearned']." , ".$data['redeemed']." , ".$data['bags']." , ".$flag.",".$data['discountFlag'].",'".$data['operator']."' )";
	       	$insert_pos_query = $this->db->query($sql);
	      	if ($this->posDetail($insert_pos_query,$data['bill_items'])){
				$this->setLastPOS($data['billno'], $data['grandTotal']);
	         	echo json_encode(['success'=>'true']);
	      	}
	      	else{
	        	echo json_encode(['success'=>'false']);
	      	}
	    }
	    else{
	       	$id = (int)$data['posid'];
           	$sql = "UPDATE tblpos SET PartyCode='".$data['phone']."' ,  Partyname = '".$data['partyname']."' ,PartyAddress = '".$data['phone']."' ,PartyEmail = '".$data['email']."' ,Total = ".$data['subTotal']." , discountperc =  ".$data['discperc'].", TotalDiscount = ".$data['disc']." ,SGST= ".$data['sgst'].",CGST= ".$data['cgst'].",CESS= ".$data['cess']." ,GrandTotal= ".$data['grandTotal']." ,RoundOff=  ".$data['roundof'].",BillAmount= ".$data['netTotal']." ,PayType='".$data['paytype']."',paidamount=".$data['cashreceived'].",changeamount= ".$data['balance'].",pointsearned= ".$data['pointsearned'].",pointsredeemed= ".$data['redeemed'].",noofbags=".$data['bags']." ,isPending =  ".$flag.",isdiscountapplied = ".$data['discountFlag'].",CreatedBy = '".$data['operator']."' WHERE posid = $id";
           	$update_pos_query = $this->db->query($sql);
	      	if ($this->deletePosDetail($id)){
	         	if ($this->posDetail($id,$data['bill_items'])){
	             	echo json_encode(['success'=>'true']);
	         	}
	      	}
	    }
 	}
	public function setLastPOS($bill_no, $bill_amt) {
		$settings = new ServerHelper\Settings();
		$last_bill_no   = $settings->GetStoredValue('last_bill_no'  , 0);
		$last_bill_amt  = $settings->GetStoredValue('last_bill_amt' , 0);
		$last_bill_date = $settings->GetStoredValue('last_bill_date', 0);

		if (date('Y-m-d') == date('Y-m-d', $last_bill_date)) {
			if ($bill_no > $last_bill_no) {
				$settings->SetStoredValue('last_bill_no', $bill_no);
				$settings->SetStoredValue('last_bill_amt', $bill_amt);
			}
		}
	}
 	public function posDetail($posid,$item){

 		$base_query = "INSERT into tblposdetails(postblid , ItemCode , ItemName, MRP, Rate, Qty,freeqty, Unit, Amount, DiscAmt , taxableamt, taxrate, sgsttax, cgsttax,cesstax,cessrate) VALUES";

 		$values = '';

 		foreach ($item as $key => $value) {

 			$values .= "(".$posid.",'".$value['code']."','".$value['name']."',".$value['price'].",".$value['price'].",".$value['qty'].",NULL,'".$value['unit']."',".$value['total'].",".$value['disc_price'].",".$value['taxableamt'].",".$value['tax'].",".$value['sgst'].",".$value['cgst'].",".$value['cessamt'].",".$value['cesstax']."),";
 	

           if (isset($value['availableFreeItems'])) {

 			foreach ($value['availableFreeItems'] as $key1 => $value1) {

 				$values .=  "(".$posid.",'".$value1['freeitemcode']."','".$value1['freename']."',NULL,NULL,NULL,".$value1['freeqty'].",'".$value1['unit']."',NULL,NULL,NULL,NULL,NULL),";
 			}

          }

 		}

 		$sql = rtrim($base_query.$values,',');

 		return $this->db->query($sql);
 	}
 	public function deletePosDetail($posid){

 		$sql = 'DELETE FROM `tblposdetails` WHERE postblid = '.$posid;
 		// echo $sql;

 		if ($this->db->query($sql)) {
 			return true;
 		}
 		return false;
 	}
 	public function deletePos($posid){

 		$sql = 'DELETE FROM `tblpos` WHERE posid = '.$posid;
 		// echo $sql;

 		if ($this->db->query($sql)) {
 			return true;
 		}
 		return false;
 	}
 	public function UnsavedPos($data){

 		$today = date("Y-m-d");
 		 
        if (!$data['unsavedbill']) {

	 		$sql = "INSERT into tblposunsaved( postblid,BranchId , counterno , InvDate , BillNo ,Partyname,PartyAddress,PartyEmail,Total,discountperc,TotalDiscount,SGST,CGST,CESS,GrandTotal,RoundOff,BillAmount,PayType,paidamount,changeamount,noofbags,isPending,isdiscountapplied,CreatedBy) VALUES (".$data['posid']." , ".$data['branchid']." , ".$data['counter']." , '".$today."' , ".$data['billno']." ,'".$data['partyname']."' , '".$data['phone']."' , '".$data['email']."' ,".floatval($data['subTotal'])." , ".floatval($data['discperc'])." , ".floatval($data['disc'])." , ".floatval($data['sgst'])." , ".floatval($data['cgst'])." , ".floatval($data['cess'])." , ".floatval($data['grandTotal'])." , ".floatval($data['roundof'])." , ".floatval($data['netTotal'])." , '".$data['paytype']."' , '".floatval($data['cashreceived'])."' , '".floatval($data['balance'])."' , '".floatval($data['bags'])."' , 1 ,'".floatval($data['discountFlag'])."','".$data['operator']."')";

	      

	       $insert_pos_query = $this->db->query($sql);

	      if ($this->UnsavedPosDetail($insert_pos_query,$data['bill_items'])){

	         echo json_encode(['success'=>'true','UnsavedPos'=>$insert_pos_query]);

	      }

	      else{

	         echo json_encode(['success'=>'false']);

	      }
	    }
	    else{
	       $id = (int)$data['unsavedbill'];

           $sql = "UPDATE tblposunsaved SET  Partyname = '".$data['partyname']."' ,PartyAddress = '".$data['phone']."' ,PartyEmail = '".$data['email']."' ,Total = ".floatval($data['subTotal'])." , discountperc =  ".floatval($data['discperc']).", TotalDiscount = ".floatval($data['disc'])." ,SGST= ".floatval($data['sgst']).",CGST= ".floatval($data['cgst'])." ,CESS= ".floatval($data['cess']).",GrandTotal= ".floatval($data['grandTotal'])." ,RoundOff=  ".floatval($data['roundof']).",BillAmount= ".floatval($data['netTotal'])." ,PayType='".floatval($data['paytype'])."',paidamount=".floatval($data['cashreceived']).",changeamount= ".floatval($data['balance']).",noofbags=".floatval($data['bags'])." ,isPending = 1 ,isdiscountapplied = ".intval($data['discountFlag'])." ,CreatedBy = '".$data['operator']."' WHERE posid = $id";
           $update_pos_query = $this->db->query($sql);

          
	      if ($this->deleteUnsavedPosDetail($id)){

	         if ($this->UnsavedPosDetail($id,$data['bill_items'])){

	             echo json_encode(['success'=>'true']);

	         }

	      }
	    }
 	}
 	public function UnsavedPosDetail($posid,$item){
 		if (!$item) {
 			return true;
 		}
 		$base_query = "INSERT into tblposunsaveddetails(postblid , ItemCode , ItemName, MRP, Rate, Qty,freeqty, Unit, Amount, DiscAmt , taxableamt, taxrate, sgsttax, cgsttax,cessrate,cesstax) VALUES";

 		$values = '';

 		foreach ($item as $key => $value) {

 			$values .= "(".$posid.",'".$value['code']."','".$value['name']."',".$value['price'].",".$value['price'].",".$value['qty'].",NULL,'".$value['unit']."','".floatval($value['total'])."','".floatval($value['disc_price'])."','".floatval($value['taxableamt'])."','".floatval($value['tax'])."','".floatval($value['sgst'])."','".floatval($value['cgst'])."','".floatval($value['cesstax'])."','".floatval($value['cessamt'])."'),";

           if (isset($value['availableFreeItems'])) {

 			foreach ($value['availableFreeItems'] as $key1 => $value1) {

 				$values .=  "(".$posid.",'".$value1['freeitemcode']."','".$value1['freename']."',NULL,NULL,NULL,".$value1['freeqty'].",'".$value1['unit']."',NULL,NULL,NULL,NULL,NULL,NULL),";
 			}

          }

 		}

 		$sql = rtrim($base_query.$values,',');

 		return $this->db->query($sql);
 	}
 	public function deleteUnsavedPosDetail($posid){

 		$sql = 'DELETE FROM `tblposunsaveddetails` WHERE postblid = "'.$posid.'" AND isdeleted = 0';

 		if ($this->db->query($sql)) {
 			return true;
 		}
 		return false;
 	}
 	public function TrackDeletedItems($code,$rate,$bill)
 	{
 		$deletedItem = "UPDATE tblposunsaveddetails SET  isdeleted = 1 WHERE postblid =".$bill." AND ItemCode ='".$code."' AND Rate =".$rate ;
 		if ($this->db->query($deletedItem)) {
 			return true;
 		}
 		return false;
 	}
 	public function closeUnsavedpos($unsavedbill){

 	    $sql = 'UPDATE `tblposunsaved` SET isPending = 0 WHERE posid = '.$unsavedbill;
 	
 		$deletedItem = "DELETE FROM tblposunsaveddetails WHERE  isdeleted = 0 AND postblid =".$unsavedbill ;
        $this->db->query($sql);
        $this->db->query($deletedItem);
 	}
 	public function getBillNo($counter) {
		$settings = new ServerHelper\Settings();
		$last_bill_no  = $settings->GetStoredValue('last_bill_no', 0);
		$last_bill_amt = $settings->GetStoredValue('last_bill_amt', 0);
		$bill_date     = $settings->GetStoredValue('last_bill_date', 0);

		if (date('Y-m-d') == date('Y-m-d', $bill_date)) {
			 echo json_encode(['success' => true, 'reason' => 'Details Found', 'details' => ['BillAmount' => $last_bill_amt, 'BillNo' => $last_bill_no]]);
		}
		else {
			$settings->SetStoredValue('last_bill_no', 0);
			$settings->SetStoredValue('last_bill_amt', 0);
			$settings->SetStoredValue('last_bill_date', time());
			echo json_encode(['success' => true, 'reason' => 'Details Found', 'details' => ['BillAmount' => 0, 'BillNo' => 0]]);
		}

		return;

 		$today = date("Y-m-d");
        $query = $this->db->query("SELECT max(BillNo) as BillNo from tblpos where counterno = '$counter' AND InvDate = '".$today."'");

        if ($query && $query->num_rows) {

	        $item = $query->fetchArray();
	        $query1 = $this->db->query("SELECT BillAmount from tblpos where counterno = '$counter' AND BillNo = '".$item['BillNo']."' AND InvDate = '".$today."'");

	        $item1 = $query1->fetchArray();
	        $item['BillAmount'] = $item1['BillAmount'];

			$item['BillNo'] = max($item['BillNo'], $last_bill_no);

	          echo json_encode(['success' => true, 'reason' => 'Details Found', 'details' => $item]);

	    } else {

              echo json_encode(['success' => false, 'reason' => 'Item Not Found', 'details' => []]);

	    }
 	}

 	public function shiftClose($date){
        $this->reCalculateShiftClose($date);
 		$query = $this->db->query("SELECT * FROM tblshiftclosing WHERE DATE(trandate) = '".$date."'");
 		if ($query && $query->num_rows) {
	        $item = $query->fetchAllArray();
	        foreach ($item as $key => $value) {
	        	$item[$key]['totalbills'] = (int) $value['noofcashbills'] + (int) $value['noofcreditbills']; 
	        	$item[$key]['total'] = (int) $value['cardsales'] + (int) $value['cashsales'];
	        	$item[$key]['points'] = (int) $value['pointsales'];
                $item[$key]['adjustments']= (object)[];
                $adj_query = $this->db->query("select * from tblshiftclosingadjustdetails WHERE shiftno='{$item[$key]['shiftno']}'");
                if ($adj_query && $adj_query->num_rows) {
                    $item[$key]['adjustments'] = $adj_query->fetchAllObject();
                }
	        }
	        echo json_encode(['success'=>true,'details'=>$item]);
	        exit;
	    }
	    else{
	    	echo json_encode(['success'=>false,'details'=>[]]);
	        exit;
	    }
 	}
 	public function closeBills($bills,$user){

 		foreach ($bills as $key => $value) {
            $remitted_amt = isset($value['remittedTotal']) ? $value['remittedTotal'] : 0;
            $adjusted = isset($value['adjusted']) ? $value['adjusted'] : 0;
            $remitted = $this->db->query("UPDATE tblshiftclosing SET remitted = '$remitted_amt', closedby = '$user',adjusted='$adjusted' WHERE shiftno =".$value['shiftno'] );
            if ($remitted){
                $sql = $this->db->query("DELETE FROM tblshiftclosingadjustdetails WHERE shiftno = {$value['shiftno']}");
                if (!$sql) {
                    echo json_encode(['success'=>false]);
                    exit;
                }

                if(isset($value['adjustments'])) {
                    foreach ($value['adjustments'] as $k=>$v){
                        $add_adjustmnt_det = $this->db->query("insert into tblshiftclosingadjustdetails(shiftno, Remarks, Amount)
		values ({$value['shiftno']},'{$v['Remarks']}',{$v['Amount']})");
                        if(!$add_adjustmnt_det) {
                            echo json_encode(['success'=>false]);
                            exit;
                        }
                    }
                } else {
                    $add_adjustmnt_det = $this->db->query("insert into tblshiftclosingadjustdetails(shiftno, Remarks, Amount)
		values ({$value['shiftno']},'Adjustment',{$value['adjusted']})");
                    if(!$add_adjustmnt_det) {
                        echo json_encode(['success'=>false]);
                        exit;
                    }
                }
            }
	    else{
	    	echo json_encode(['success'=>false]);
	        exit;
	    }

 		}
	      echo json_encode(['success'=>true]);
	        exit;
 	}
 	public function counterDetails(){
 		$counter = $this->db->query("SELECT counterid,counterkey FROM tblcountersettings WHERE keyenabled = 0");
 		if ($counter && $counter->num_rows) {
 			$counters = $counter->fetchAllArray();
 			echo(json_encode(['success'=>true,'counters'=>$counters]));
 			exit;
 		}
 		else{
 			echo json_encode(['success'=>false,'msg'=>'All the Counters are enabled']);
 			exit;
 		}
 	}
 	public function enablecounter($id){
 		$counter = $this->db->query("SELECT keyenabled FROM tblcountersettings WHERE counterid =".$id);
 		$counters = $counter->fetchArray();
 		if ($counters['keyenabled'] == 1) {
 			  echo json_encode(['success'=>False,'msg'=>'Someone Enabled this Counter Just Now...']);
 			exit;
 		}
 		else{

 			$okay = $this->db->query("UPDATE tblcountersettings SET keyenabled = 1 WHERE counterid =".$id);
 			if ($okay) {
 			  echo json_encode(['success'=>TRUE,'msg'=>'Successfully Enabled']);
 			  exit;
 			}
 			  echo json_encode(['success'=>False,'msg'=>'Something Went Wrong...']);

 			exit;
 		}
 	}
 	public function getcounterno($key)
 	{
 		$counter = $this->db->query("SELECT * FROM tblcountersettings WHERE counterkey ='".$key."'");
 		if ($counter && $counter->num_rows) {

 		    $counters = $counter->fetchArray();
 			echo json_encode(['success'=>true,'counter'=>$counters]);
 			exit;
 		}
 		else{
 			echo json_encode(['success'=>false,'msg'=>'Something Went Wrong...']);
 			exit;
 		}
 	}
 	public function CloseCoutnterBill($counterno, $operator)
    {
        $trandate = $this->db->query("SELECT trandate FROM tblshiftclosing WHERE operator = '".$operator."' AND counterno =".$counterno." ORDER BY shiftno DESC LIMIT 1");
        $wheredate = '';
        $wheredatereturn = '';
        if ($trandate && $trandate->num_rows) {
            $trandate = $trandate->fetchArray();
            $wheredate = "AND CreatedDateTime > '".$trandate['trandate']."'";
            $wheredatereturn = "AND returntime > '".$trandate['trandate']."'";
        }

        $query = $this->db->query("SELECT counterno,SUM(BillAmount) as full ,SUM(RoundOff) as adjusted, CreatedBy ,COUNT(BillNo) as bills,InvDate,MAX(BillNo) as endbill , MIN(BillNo) as startbill , MAX(CreatedDateTime) as endtime , MIN(CreatedDateTime) as starttime FROM tblpos WHERE counterno = ".$counterno." AND CreatedBy = '".$operator."' ".$wheredate." AND accountsettled = 0 AND isPending = 0 GROUP BY counterno,CreatedBy");
        if ($query && $query->num_rows) {
            $item = $query->fetchAllArray();
            foreach ($item as $key => $value) {
                $where = $value['CreatedBy'] ? "AND CreatedBy='".$value['CreatedBy']."'" : "";
                $cash_query = $this->db->query("SELECT SUM(BillAmount) as cash , COUNT(BillNo) as countcash FROM tblpos WHERE accountsettled = 0 AND counterno ='".$value['counterno']."' ".$where." AND PayType='cash' AND isPending = 0 ".$wheredate);

                $card_query  = $this->db->query("SELECT SUM(BillAmount) as card , COUNT(BillNo) as countcard FROM tblpos WHERE accountsettled = 0 AND counterno ='".$value['counterno']."' ".$where." AND PayType !='cash' AND isPending = 0 ".$wheredate);
                $point_query = $this->db->query("SELECT SUM(pointsredeemed) as points , COUNT(BillNo) as countpoints FROM tblpos WHERE accountsettled = 0 AND counterno ='".$value['counterno']."' ".$where." AND pointsredeemed IS NOT NULL AND isPending = 0 ".$wheredate);
                $cash_return = $this->db->query("SELECT SUM(amountrepaid) as cashrepaid  FROM tblposreturn WHERE accountsettled = 0 AND settlecounterno ='".$value['counterno']."'".$wheredatereturn);

                $cash = $cash_query->fetchArray();
                $card = $card_query->fetchArray();
                $point = $point_query->fetchArray();
                $cashreturn = $cash_return->fetchArray();

                $item[$key]['cash'] = (int) $cash['cash'] - (int) $cashreturn['cashrepaid'];
                $item[$key]['cashrepaid'] = (int) $cashreturn['cashrepaid'];
                $item[$key]['countcash'] = $cash['countcash'];
                $item[$key]['card'] = $card['card'];
                $item[$key]['countcard'] = $card['countcard'];
                $item[$key]['points'] = $point['points'];
                $item[$key]['countpoints'] = $point['countpoints'];
            }
            echo json_encode(['success'=>true,'details'=>$item]);
        }
        else{
            echo json_encode(['success'=>false,'details'=>[]]);
        }
    }
 	public function addShiftClose($data,$branchid) {
 		$starttime = date("H:i:s",strtotime($data['starttime']));
 		$endtime = date("H:i:s",strtotime($data['endtime']));
 		$cardsales = $data['card'] != '' ? $data['card'] : 0 ;
 		$cashsales = $data['cash'] != '' ? $data['cash'] : 0 ;
 		$pointsales = $data['points'] != '' ? $data['points'] : 0 ;
 		$pointcount = $data['countpoints'] != '' ? $data['countpoints'] : 0 ;
 		$add = $this->db->query("INSERT INTO `tblshiftclosing`(`Branchid`, `counterno`, `operator`, `noofcashbills`, `noofcreditbills` , `noofpointbills`, `cashsales`, `cardsales` , `pointsales`, `adjusted`,`starttime`,`endtime`,`startbillno`,`endbillno`) VALUES ( ".$branchid." , ".$data['counterno']." , '".$data['CreatedBy']."' , ".$data['countcash']." , ".$data['countcard']." , ".$pointcount." , ".$cashsales." , ".$cardsales." , ".$pointsales." , ".$data['adjusted'].", '".$starttime."', '".$endtime."', ".$data['startbill'].", ".$data['endbill']." )");
 		if($add) {
 			echo json_encode(['success'=>true]);
 		}
 		else {
 			echo json_encode(['success'=>false]);
 		}
 	}
    public function reCalculateShiftClose($date) {
         $query = $this->db->query("SELECT *  FROM tblshiftclosing WHERE DATE(trandate) = '".$date."'");
         if ($query && $query->num_rows) {
             $bills = $query->fetchAllArray();
            foreach ($bills as $key => $value) {
                $cash_query = $this->db->query("SELECT SUM(BillAmount) as cash , COUNT(BillNo) as countcash FROM tblpos WHERE counterno ='" . $value['counterno'] . "'  AND PayType='cash' AND BillNo BETWEEN '" . $value['startbillno'] . "' AND '" . $value['endbillno'] . "' AND InvDate = date('" . $value['trandate'] . "')");
                $card_query = $this->db->query("SELECT SUM(BillAmount) as card , COUNT(BillNo) as countcard FROM tblpos WHERE counterno ='" . $value['counterno'] . "'  AND PayType !='cash' AND BillNo BETWEEN '" . $value['startbillno'] . "' AND '" . $value['endbillno'] . "' AND InvDate = date('" . $value['trandate'] . "')");
                $point_query = $this->db->query("SELECT SUM(pointsredeemed) as points , COUNT(BillNo) as countpoints FROM tblpos WHERE counterno ='" . $value['counterno'] . "'  AND pointsredeemed IS NOT NULL AND BillNo BETWEEN '" . $value['startbillno'] . "' AND '" . $value['endbillno'] . "' AND InvDate = date('" . $value['trandate'] . "')");
                $cash = $cash_query->fetchArray();
                $card = $card_query->fetchArray();
                $point = $point_query->fetchArray();
                $cashTotal = $cash['cash'];
                $countcash = $cash['countcash'];
                $cardTotal = $card['card'];
                $countcard = $card['countcard'];
                $points = $point['points'];
                $countpoints = $point['countpoints'];
                $amount = 0;
                $adj_query = $this->db->query("select sum(Amount) AS Amount from tblshiftclosingadjustdetails WHERE shiftno =" . $value['shiftno']);
                if ($adj_query && $adj_query->num_rows) {
                     $amount = $adj_query->fetchObject()->Amount;
                }
                $update = $this->db->query("UPDATE tblshiftclosing SET noofcashbills = '$countcash',noofcreditbills = '$countcard',noofpointbills= '$countpoints',cashsales = '$cashTotal',cardsales = '$cardTotal',pointsales = '$points' ,adjusted = '$amount' WHERE shiftno =" . $value['shiftno']);
                if (!$update) {
                    echo json_encode(['success' => false]);
                    exit;
                }
             }
         }
    }
    public function loadReturnBill($counter,$bill,$date){
         
        $retsql = "SELECT * from tblposreturn WHERE orgCounterno = '$counter' AND orgBillno = '$bill' AND orgInvdate = '".$date."'"; 
        $retbill = $this->db->query($retsql);
        
        if ($retbill->num_rows > 0) { 
            echo json_encode(['success'=>false,'msg'=>'Bill already return']);
            exit;
        } 
         
        $sql = "SELECT * from tblpos WHERE counterno = $counter AND BillNo = $bill AND InvDate = '".$date."'";
        // echo $sql;die();
        $bills = [];
        $bill = $this->db->query($sql);

        if ($bill && $bill->num_rows) {

            $bills = $bill->fetchArray();

            $sql1 = "SELECT * FROM tblposdetails WHERE postblid = ".$bills['posid'];

            $item = $this->db->query($sql1);

            if ($item && $item->num_rows) {

              $items = $item->fetchAllArray();

              $bills['items'] = $items;

            }
            echo(json_encode(['success'=>true,'counters'=>$bills]));

            exit;
        }
        else{
            echo json_encode(['success'=>false,'msg'=>'Please Enter a Valid Detail']);
            exit;
        }
    }
    public function processReturn($counter, $returndata, $repayAmount, $operator, $settlecounterno) {
        $today = date("Y-m-d"); 
        $data = $returndata[0];  
         
        $settlesql = $this->db->query("SELECT CreatedBy FROM tblpos WHERE counterno = '".$data['counterno']."' AND InvDate = '".$data['InvDate']."'");
        $settle = $settlesql->fetchArray();
        $settlementby = $settle["CreatedBy"];
        
        $sql = "INSERT into tblposreturn( BranchId , settlecounterno , InvDate , BillNo , PartyCode ,Partyname, PartyAddress, PartyEmail,amountrepaid, Total, discountperc, TotalDiscount, isdiscountapplied, SGST, CGST, IGST, GrandTotal, RoundOff, BillAmount, PayType, paidamount, changeamount, noofbags, accountsettled, isPending, shiftno, CreatedBy, CreatedDateTime, AmendedBy, AmendedDateTime, orgPosid, orgCounterno, orgBillno, orgInvdate, settlementby) VALUES ( '".$data['BranchId']."' , '".$settlecounterno."' , '".$data['InvDate']."' , '".$data['BillNo']."' ,'".$data['PartyCode']."','".$data['Partyname']."','".$data['PartyAddress']."','".$data['PartyEmail']."' ,'".$repayAmount."','".$data['Total']."', '".$data['discountperc']."', '".$data["TotalDiscount"]."', '".$data["isdiscountapplied"]."', '".$data["SGST"]."', '".$data["CGST"]."', '".$data["IGST"]."', '".$data['GrandTotal']."' , '".$data['RoundOff']."' , '".$data['BillAmount']."' , '".$data['PayType']."' , '' , '' , '".$data['noofbags']."',0, '".$data['isPending']."', '".$data["shiftno"]."', '".$data["CreatedBy"]."', '".$data["CreatedDateTime"]."', '".$data["AmendedBy"]."', '".$data["AmendedDateTime"]."' , '".$data["posid"]."', '".$data["counterno"]."', '".$data["BillNo"]."','".$data['InvDate']."', '".$settlementby."')";
        
        $add = $this->db->query($sql);
        
        $postblid = $this->db->insert_id();
        
        $base_query = "INSERT into tblposreturndetails(postblid , ItemCode , ItemName, MRP, Rate, Qty,freeqty, Unit, Amount, DiscAmt , taxableamt, taxrate, sgsttax, cgsttax, igsttax) VALUES";

        $values = '';
        
        $addet = "";
        $posid = $data["posid"]; 
        
        if($posid != "0") { 
            
            $item = $data["items"];
            
            foreach ($item as $key => $value) {
                 
                if($value["returnAmount"] > 0) { 
               
                    $values .= "(".$postblid.", '".$value['ItemCode']."', '".$value['ItemName']."', '".$value['MRP']."', '".$value['Rate']."', '".$value['returnQty']."', '','".$value['Unit']."', '".$value['returnAmount']."', '".$value['DiscAmt']."', '".$value['taxableamt']."', '".$value['taxrate']."', '".$value['sgsttax']."', '".$value['cgsttax']."', '".$value['igsttax']."'),";
                }
            } 
            $sqldet = rtrim($base_query.$values,','); 
            
            $addet = $this->db->query($sqldet);
        }
        
        if($addet) { 
        	echo json_encode(['success'=>true]);
        }
        else {
        	echo json_encode(['success'=>false]);
        }
    } 
	public function login($usercode, $pass, $user_branch) {

		$s_time = '9:00';
		$e_time = '18:00';

		$sql = "select CategoryName, Type from tbldefaultsettings s where CategoryName = 'Login Start Time' or CategoryName = 'Login Stop Time'";
		$result = $this->db->query($sql);
		if ($result && $result->num_rows) {
			while ($row = $result->fetchArray()) {
				if ($row['CategoryName'] === 'Login Start Time') {
					$s_time = $row['Type'];
				}
				elseif ($row['CategoryName'] === 'Login Stop Time') {
					$e_time = $row['Type'];
				}
			}
		}

		$date = date('Y-m-d');
		$time = strtotime(date('Y-m-d H:i'));

		$time_1 = strtotime($date . ' ' . $s_time);
		$time_2 = strtotime($date . ' ' . $e_time);

		if ($time < $time_1 || $time > $time_2) {
			echo json_encode(['success'=> false, 'message' => 'Login allowed only in work hours.']);
			exit;
		}
		//$sql = "select usr.UserCode,usr.acccode,usr.DefaultScreen,mas.Picture as image,mas.AccName as name from tbluseremployee usr join tblaccmas mas on mas.AccCode = usr.acccode where usr.UserCode = '$usercode' and usr.Password = '$pass' and  FIND_IN_SET('$user_branch', mas.AvailableBranches) and Status = 1";
		$sql = "select usr.UserCode,usr.acccode,usr.DefaultScreen, usr.imagefile as image, usr.UserCode as name from tbluseremployee usr where usr.UserCode = '$usercode' and usr.Password = '$pass'";
		$result = $this->db->query($sql);
		if ($result && $result->num_rows) {
			$result = $result->fetchArray();

			$_SESSION['UserCode'] = $result['UserCode'];
			$_SESSION['UserId'] = $result['acccode'];
			$_SESSION['UserImage'] = $result['image'];
			$_SESSION['UserName'] = $result['name'];
			$_SESSION['Branch'] = $user_branch;

			//$_SESSION['database'] = ['db_name' => $config['database'], 'db_user' => $config['username'], 'db_password' => $config['password'], 'branchname' => ''];

			/*$sql_db = "select * from tblclientdetails where branchcd='$user_branch'";
			$result = $this->db->query($sql_db);
			if ($result && $result->num_rows) {
				$result_db = $result->fetchObject();
                $_SESSION['database'] = ['db_name' => $result_db->branchdbname, 'db_user' => $result_db->branchusrname, 'db_password' =>$result_db->branchpassword, 'branchname' =>$result_db->branchname];
				echo json_encode(['success'=>true, 'login'=> ['branch' => $_SESSION['Branch'], 'name' => $_SESSION['UserName'], 'code' => $_SESSION['UserCode']]]);
				exit;
			}*/

			echo json_encode(['success'=>true, 'login'=> ['branch' => $_SESSION['Branch'], 'name' => $_SESSION['UserName'], 'code' => $_SESSION['UserCode']]]);
			exit;
		}

		echo json_encode(['success'=> false, 'message' => 'Unable to login. Please check your credentials.']);
		exit;
	}
	public function getBranch($user) {
		global $settings;

		$branch_details = [];
		$sql = "select BranchId,BranchName from tblbranch";
		
		$sql .= " where BranchId = '{$settings->BranchId}'";

		$branch = $this->db->query($sql);
		if ($branch && $branch->num_rows) {
			while($row = $branch->fetchObject()) {
				$branch_details[] = ['branch_id'=> $row->BranchId, 'branch_name'=> $row->BranchName];
			}

			echo(json_encode(['success'=> true, 'branch'=> $branch_details]));
			return;
		}
		echo json_encode(['success' => false, 'message' => 'No Branch Found', 'branch' => []]);
		return;
	}
	public function getCompany() {
        $settings = new ServerHelper\Settings();
		$sql ="SELECT BranchName as name, Address as address, City as city, State as state, Country as country, PinCode as pincode, MobileNumber as mobile, Telephone as phone, GstRegisNo as gst_reg_no, (SELECT name FROM `countries` WHERE id = Country) as country, (SELECT name FROM `states` WHERE id = State) as state  FROM tblbranch WHERE BranchId = '{$settings->BranchId}'";
		$company = $this->db->query($sql);
		if ($company && $company->num_rows) {
			 $company = $company->fetchArray();

			 $sql = "select Type from tbldefaultsettings where CategoryName = 'POS Print Tax'";
			 $settings_obj = $this->db->query($sql);
			 $settings = [];
			 if ($settings_obj && $settings_obj->num_rows) {
				$settings['print_tax'] = ($settings_obj->fetchArray()['Type'] == '1');
			 }

			 echo(json_encode(['success'=>true, 'company'=>$company, 'settings'=>$settings]));
			 return;
		}
	    echo(json_encode(['success'=> false, 'message'=> 'Could not get company details']));
		return;
	}
	public function getMemberStorage() {
		$sql ="SELECT CategoryName , Type FROM tbldefaultsettings WHERE CategoryName = 'Pointsfor100Rupees' OR  CategoryName = 'Memberlocalstorage'";
		$MemberStorage = $this->db->query($sql);
		if ($MemberStorage && $MemberStorage->num_rows) {
			$MemberStorage = $MemberStorage->fetchAllArray();
			echo(json_encode(['success'=>true, 'MemberStorage'=>$MemberStorage]));
			return;
		}
	    echo(json_encode(['success'=> false, 'message'=> 'Could not get company details']));
		return;
	}
	public function getMember($member,$inner=false)
	{
		$sql ="SELECT memberid,membername,address,pointsbalance,totalcollected,totalredeemed FROM tblmemberrewardpoints WHERE mobileno = $member";
		$Member = $this->db->query($sql);
		if ($Member && $Member->num_rows) {
			$Member = $Member->fetchArray();
			if($inner){
				return $Member;
			}
			else{
				echo(json_encode(['success'=>true, 'Member'=>$Member]));
				return;
			}
		}
		if($inner){
				return false;
		}
		else{
			echo(json_encode(['success'=>false]));
			return;
		}
	}
	public function addMember($member,$address)
	{
		$sql ="INSERT INTO tblmemberrewardpoints (mobileno,address) VALUES ('".$member."','".$address."')";
		$Member = $this->db->query($sql);
		if ($Member) {
				echo(json_encode(['success'=>true, 'Member'=>$Member]));
				return;
		}
		echo(json_encode(['success'=>false, 'msg'=>'Something Went Wrong']));
		return;
	}
	public function processRedeem($member, $points, $earned)
	{
		$conec = $this->checkConnection();
		if (!$conec) {
			return false;			
		}
		$change = $this->changeDB($this->alterDB);
		if (!$change) {
			return false;			
		}
		$member = $this->getMember($member,true);
		if (!$member) {
			return false;			
		}
		$upres = $this->updateMemberPoints($member,$points,$earned);
		if (!$upres) {
			return false;
		}
		$change = $this->changeDB($this->currentDB);
		return true;
	}
	public function updateMemberPoints($member,$redeemed,$earned)
	{
		$totalpoints = $member['totalcollected'] + $earned;
		$totalredeemed = $member['totalredeemed'] + $redeemed;
		$pointsbalance = ($member['pointsbalance'] - $redeemed) + $earned;
		$sql ="UPDATE tblmemberrewardpoints SET pointsbalance = $pointsbalance, totalcollected = $totalpoints, totalredeemed = $totalredeemed WHERE memberid =".$member['memberid'];
		$points = $this->db->query($sql);
		if($points){
			return true;
		}
		return false;
	}
	public function changeDB($db)
	{
		$this->db = mysql::getInstance($db);
		if($this->db){
			return true;
		}
		return false;
	}
	public function checkConnection()
	{
		$settings = new ServerHelper\Settings();
		return $settings->ping("aanjaneyamushroomfarm.com");
	}
	public function logOut() {
		session_destroy();
		echo json_encode(['success' => true]);
	}
 }
