<?php
session_name("acc_pos");
session_start();
function tryLogin() {
    if(!isset($_SESSION['UserCode'])) {
        header("Location: login.php");
        exit();
    }
}
/**
 * Created by PhpStorm.
 * User: Accordex PC
 * Date: 24-03-2018
 * Time: 05:14 PM
 */

include_once __DIR__ . '/class/mysql/mysql.php';
include_once __DIR__ . '/class/app/ClassApp.php';
include_once __DIR__ . '/Settings.php';
const TIME_ZONE = 'Asia/Kolkata';


$settings   = new ServerHelper\Settings();
$config_bd   = $settings->BaseDatabase;
$config_bkd  = $settings->BackupDatabase;
$config_sd   = $settings->ServerDatabase;

$config_md  = $settings->LocalMasterDatabase;
$config_smd = $settings->ServerMasterDatabase;

date_default_timezone_set(TIME_ZONE);
// Base
$config = [
    "hostname"  => $config_bd->HostName,
    "database"  => $config_bd->Database,
    "username"  => $config_bd->UserName,
    "password"  => $config_bd->Password,
    "exit_on_error" => true,
    "echo_on_error" => true,
];

// Backup
$bk_config = [
    "hostname"  => $config_bkd->HostName,
    "database"  => $config_bkd->Database,
    "username"  => $config_bkd->UserName,
    "password"  => $config_bkd->Password,
    "exit_on_error" => true,
    "echo_on_error" => true,
];

// Server Master
$clientCloud = [
    "hostname"  => $config_smd->HostName,
    "database"  => $config_smd->Database,
    "username"  => $config_smd->UserName,
    "password"  => $config_smd->Password,
    "exit_on_error" => false,
    "echo_on_error" => true,
];

$db = getDatabaseConnection();

header('Content-type:application/json;charset=utf-8');
header("Cache-Control: no-cache, must-revalidate"); // HTTP 1.1
header("Pragma: no-cache"); // HTTP 1.0
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // Date in the past

function cors() {
    header("Access-Control-Allow-Origin: *");

    if (isset($_SERVER['HTTP_ORIGIN'])) {
        header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
        header('Access-Control-Allow-Credentials: true');
        header('Access-Control-Max-Age: 86400');
    }

    if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
            header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         

        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
            header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");

        exit(0);
    }
}

function getDatabaseConnection() {
	global $settings, $config, $bk_config;

	$last_conn = $settings->GetConnection('default');
	$last_conn_time = $settings->GetStoredValue('last_conn_time', time());
	$current_conn = 'default';

	if($last_conn == 'default' || ($last_conn_time + 3600) < time()) {
		try {
			$settings->SetConnection('default');
			$settings->SetStoredValue('last_conn_time', time());
			$current_conn = 'default';
			$db = mysql::getInstance($config);
		}
		catch(Exception $e) {
			$settings->SetConnection('back_up');
			$settings->SetStoredValue('last_conn_time', time());
			$current_conn = 'back_up';
			$db = mysql::getInstance($bk_config);
		}
	}
	else {
		$current_conn = 'back_up';
		$db = mysql::getInstance($bk_config);
	}

	header("x-db-connection: $current_conn");

	return $db;
}

cors();