<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 10/16/2019
 * Time: 1:25 AM
 */


class BatchRatePull extends PullPush
{
    protected $lock_local = ['tblstockdetails'];

    protected $lock_server = ['tblstockdetails'];

    protected $sync_type = self::SYNC_TYPE_PULL;

    /**
     * @throws Exception
     */
    protected function loadItems()
    {
        $stock_details = [];

        $result = $this->server
            ->where('amendeddatetime', $this->last_sync_time, '>=')
            ->get('tblstockdetails');

        $stock_ids = [];
        foreach ($result as $row) {
            $id = $row['tblid'];
            $stock_ids[] = $id;
            unset($row['tblid']);
            $stock_details[$id] = $row;
        }

        if (!count($stock_ids)) {
            $this->throwNoDataException();
        }

        return [
            'stock' => $stock_details
        ];
    }

    /**
     * @param $data
     * @throws Exception
     */
    protected function saveItems($data)
    {
        foreach ($data['stock'] as $id => $stock) {
            $this->local
                ->where('itemcode', $stock['itemcode'])
                ->where('batchno', $stock['batchno'])
                ->update('tblstockdetails', $stock);

            $this->throwExceptionOnLocalError();
        }
    }
}
