<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 10/16/2019
 * Time: 1:32 AM
 */


class CounterPull extends PullPush
{
    protected $lock_local = ['tblcountersettings'];

    protected $lock_server = ['tblcountersettings'];

    protected $sync_type = self::SYNC_TYPE_PULL;


    /**
     * @throws Exception
     */
    protected function loadItems()
    {
        $counter = [];

        $result = $this->server
            ->where('CreatedDateTime', $this->last_sync_time, '>=')
            ->get('tblcountersettings');

        if (!$result) {
            $this->throwNoDataException();
        }

        $item_ids = [];
        foreach ($result as $row) {
            $id = $row['counterid'];
            $counter[$id] = $row;
            $item_ids[] = $id;
        }

        return $counter;
    }

    /**
     * @param $data
     * @throws Exception
     */
    protected function saveItems($data)
    {

        foreach ($data as $id => $it) {
            $this->local
                ->onDuplicate(array_keys($it))
                ->insert('tblcountersettings', $it);

            $this->throwExceptionOnLocalError();
        }
    }
}
