<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 10/16/2019
 * Time: 1:35 AM
 */


class InvoicePull extends PullPush
{
    protected $lock_local = ['tblinvoice', 'tblinvoicedetails'];

    protected $lock_server = ['tblinvoice', 'tblinvoicedetails'];

    /**
     * @throws Exception
     */
    protected function loadItems()
    {
        $invoice = [];
        $invoice_details = [];

        $result = $this->server
            ->where('CreatedDateTime', $this->last_sync_time, '>=')
            ->where('AmendedDateTime', $this->last_sync_time, '>=', 'OR')
            ->get('tblinvoice');

        if (!$result) {
            $this->throwNoDataException();
        }

        $item_ids = [];
        foreach ($result as $row) {
            $id = $row['tblid'];
            $invoice[$id] = $row;
            $invoice_details[$id] = [];
            $item_ids[] = $id;

            $result2 = $this->server
                ->where('InvType', $row['InvType'])
                ->where('InvNo', $row['InvNo'])
                ->where('BranchId', $row['BranchId'])
                ->get('tblinvoicedetails');


            foreach ($result2 as $row2) {
                $invoice_details[$id][] = $row2;

                /* $item_code = $row2['ItemCode'];
                 if (!isset($details[$inv_type][$item_code])) {
                     $details[$inv_type][$item_code] = 0;
                 }

                 $details[$inv_type][$item_code] += $row2['Qty'];*/
            }
        }

        return [
            'invoice' => $invoice,
            'invoice_details' => $invoice_details
        ];
    }

    /**
     * @param $data
     * @throws Exception
     */
    protected function saveItems($data)
    {
        foreach ($data['invoice'] as $id => $it) {
            $this->local
                ->onDuplicate(array_keys($it))
                ->insert('tblinvoice', $it);

            $this->throwExceptionOnLocalError();

            $this->local
                ->where('InvType', $it['InvType'])
                ->where('InvNo', $it['InvNo'])
                ->where('BranchId', $it['BranchId'])
                ->delete('tblinvoicedetails');

            foreach ($data['invoice_details'][$id] as $it_attach) {
                unset($it_attach['sno']);

                $this->local
                    ->insert('tblinvoicedetails', $it_attach);

                $this->throwExceptionOnLocalError();
            }
        }
    }
}
