<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 10/16/2019
 * Time: 2:47 AM
 */


class MemberRewardUpdate extends PullPush
{
    protected $lock_local = ['tblpos'];
    protected $lock_server = ['tblmemberrewardpoints'];

    protected $sync_type = self::SYNC_TYPE_PUSH;
    protected $db_type_server = self::DB_TYPE_MASTER;

    /**
     * @throws Exception
     */
    protected function loadItems()
    {
        $pos = $this->local
            ->where('CreatedDateTime', $this->last_sync_time, '>=')
            ->get('tblpos', null, 'Pointsreward as reward, PartyCode as mobile_no');

        if (!count($pos)) {
            $this->throwNoDataException();
        }

        return $pos;
    }

    /**
     * @param $data
     * @throws Exception
     */
    protected function saveItems($data)
    {
        foreach ($data as $id => $po) {
            $this->server
                ->rawQuery("update tblmemberrewardpoints set totalcollected = totalcollected + ?, pointsbalance = totalcollected - totalredeemed where mobileno = ? limit 1", [$po['reward'], $po['mobile_no']]);

            $this->throwExceptionOnServerError();
        }
    }
}
