<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 10/16/2019
 * Time: 1:43 AM
 */


class POSPull extends PullPush
{
    protected $lock_local = ['tblpos'];

    protected $lock_server = ['tblpos'];

    protected $sync_type = self::SYNC_TYPE_PULL;

    /**
     * @throws Exception
     */
    protected function loadItems()
    {
        $pos = [];
        $pos_details = [];

        $result = $this->server
            ->where('AmendedDateTime', $this->last_sync_time, '>=')
            ->get('tblpos');

        $pos_ids = [];
        foreach ($result as $row) {
            $id = $row['posid'];
            $pos_ids[] = $id;
            unset($row['posid']);
            $pos[$id] = $row;
        }

        if (!count($pos_ids)) {
            $this->throwNoDataException();
        }

        return [
            'pos' => $pos,
            'pos_details' => $pos_details
        ];
    }

    /**
     * @param $data
     * @throws Exception
     */
    protected function saveItems($data)
    {
        foreach ($data['pos'] as $id => $po) {
			unset($po['IsSynced']);
            $this->local
                ->where('counterno', $po['counterno'])
                ->where('InvDate', $po['InvDate'])
                ->where('BillNo', $po['BillNo'])
                ->update('tblpos', $po);

            $this->throwExceptionOnLocalError();
        }
    }
}
