<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 10/16/2019
 * Time: 2:14 AM
 */


class ShiftClosePush extends PullPush
{
    protected $lock_local = ['tblshiftclosing'];

    protected $lock_server = ['tblshiftclosing', 'tblaccbal'];

    protected $sync_type = self::SYNC_TYPE_PUSH;

    /**
     * @throws Exception
     */
    protected function loadItems()
    {
        $shift_close = [];

        $result = $this->local
            ->where('trandate', $this->last_sync_time, '>=')
            ->get('tblshiftclosing');

        if (!$result) {
            $this->throwNoDataException();
        }

        $shift_close_ids = [];
        foreach ($result as $row) {
            $id = $row['shiftno'];
            $shift_close_ids[] = $id;
            unset($row['shiftno']);
            $shift_close[$id] = $row;
        }

        if (!count($shift_close_ids)) {
           $this->throwNoDataException();
        }

        return $shift_close;
    }

    /**
     * @param $data
     * @throws Exception
     */
    protected function saveItems($data)
    {
        $card_sales= 0;
        foreach ($data as $id => $po) {
            $this->server
                ->insert('tblshiftclosing', $po);

            if ($po['cardsales'] && is_numeric($po['cardsales'])) {
                $card_sales += $po['cardsales'];
            }

            $this->throwExceptionOnServerError();
        }

        if ($card_sales) {
            $update = $this->server
                ->rawQuery("update tblaccbal set dramount = dramount + ? where acccode = '1231300007'", [$card_sales]);

            if (!$update)
                $this->throwExceptionOnServerError();
        }
    }
}
