<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 11/18/2019
 * Time: 5:31 PM
 */


class StockUpdate extends PullPush
{
    protected $lock_local = ['tblitemstockbybranch'];

    protected $lock_server = ['tblitemstockbybranch'];

    protected $sync_type = self::SYNC_TYPE_PULL;

    /**
     * @throws Exception
     */
    protected function loadItems()
    {
		$ts = date("Y-m-d H:i:s", strtotime($this->last_sync_time) + 19800);
        $stocks = $this->server
            ->where('BranchId', self::$app->settings->BranchId)
            ->where('amendeddatetime', $ts, '>=')
            ->get('tblitemstockbybranch', null, 'BranchId, qtyOnHand, itemcode, amendeddatetime');

        if (!$stocks) {
            $this->throwNoDataException();
        }

        return $stocks;
    }

    /**
     * @param $data
     * @throws Exception
     */
    protected function saveItems($data)
    {

        foreach ($data as $item) {
            $up_data = [
                'qtyOnHand' => $item['qtyOnHand'],
                'amendeddatetime' => $this->local->now(),
				'BranchId' => $item['BranchId'],
				'itemcode' => $item['itemcode']
            ];

            $this->local
				->onDuplicate(array_keys($up_data))
                ->insert('tblitemstockbybranch', $up_data);

				
		//echo $this->local->getLastQuery();

            $this->throwExceptionOnLocalError();
        }
    }
}
