<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 10/16/2019
 * Time: 1:52 AM
 */


class TransferPull extends PullPush
{
    protected $lock_local = ['tbltransfer', 'tbltransferdetails'];

    protected $lock_server = ['tbltransfer', 'tbltransferdetails'];

    protected $sync_type = self::SYNC_TYPE_PULL;

    /**
     * @throws Exception
     */
    protected function loadItems()
    {
        $transfer = [];
        $transfer_details = [];

        $result = $this->server
            ->where('createddatetime', $this->last_sync_time, '>=')
            ->where('Amenderdatetime', $this->last_sync_time, '>=', 'OR')
            ->get('tbltransfer');

        if (!$result) {
            $this->throwNoDataException();
        }

        foreach ($result as $row) {
            $id = $row['tblid'];

            $transfer[$id] = $row;
            $transfer_details[$id] = [];

            $result2 = $this->server
                ->where('transtype', $row['transtype'])
                ->where('transid', $row['transid'])
                ->where('FromBranchId', $row['FromBranchId'])
                ->get('tbltransferdetails');


            foreach ($result2 as $row2) {
                $transfer_details[$id][] = $row2;
            }
        }

        return [
            'transfer' => $transfer,
            'transfer_details' => $transfer_details
        ];
    }

    /**
     * @param $data
     * @throws Exception
     */
    protected function saveItems($data)
    {
        foreach ($data['transfer'] as $id => $it) {
            $this->local
                ->onDuplicate(array_keys($it))
                ->insert('tbltransfer', $it);

            $this->throwExceptionOnLocalError();


            $this->local
                ->where('transtype', $it['transtype'])
                ->where('transid', $it['transid'])
                ->where('FromBranchId', $it['FromBranchId'])
                ->delete('tbltransferdetails');


            foreach ($data['transfer_details'][$id] as $it_attach) {
                unset($it_attach['trandetid']);
                $this->local
                    ->insert('tbltransferdetails', $it_attach);

                $this->throwExceptionOnLocalError();
            }
        }
    }
}
