<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 10/16/2019
 * Time: 1:56 AM
 */


class UserPull extends PullPush
{
    protected $lock_local = ['tbluseremployee'];

    protected $lock_server = ['tbluseremployee'];

    protected $sync_type = self::SYNC_TYPE_PULL;

    /**
     * @throws Exception
     */
    protected function loadItems()
    {
        $user_details = [];

        $result = $this->server
            ->where('createddatetime', $this->last_sync_time, '>=')
            ->get('tbluseremployee');

        $user_ids = [];
        foreach ($result as $row) {
            $user_ids[] = $row['UserCode'];
            $user_details[] = $row;
        }

        if (!count($user_ids)) {
            $this->throwNoDataException();
        }

        return $user_details;
    }

    /**
     * @param $data
     * @throws Exception
     */
    protected function saveItems($data)
    {
        foreach ($data as $id => $user) {
            $this->local
                ->insert('tbluseremployee', $user);

            $this->throwExceptionOnLocalError();
        }
    }
}
