<?php
/**
 * Project: ServerSync
 * User: Smile
 * Date: 10/16/2019
 * Time: 2:31 AM
 */


include_once "MysqliDb.php";
include_once "../Settings.php";
spl_autoload_register(function ($class_name) {
    include 'class/' . $class_name . '.php';
});

try {
    $app = new App();
    $app->connect();
    PullPush::$app = $app;
} catch (Exception $e) {
    $app->logException($e);
    $app->log('Connect To Sync Database Failed');
    exit;
}

$app->logError('Sync Started');

$pulls = ['CounterPull', 'ItemMasterPull', /*'InvoicePull',*/ 'BatchRatePull', /*'TransferPull',*/ 'POSPull', 'POSReturnPull', 'UserPull', 'StockUpdate'];
$pushes = ['POSPush', 'ShiftClosePush'];



// tested: ItemMasterPull, CounterPull, InvoicePull, UserPull, TransferPull, ShiftClosePush, POSPush
// not tested: BatchRatePull, POSPull,

//$pulls = [];
//$pushes = ['POSPush'];


foreach ($pulls as $pull) {
    try {
        (new $pull())->sync();
    } catch (Exception $e) {
        $app->logException($e);
    }

    $app->log($pull . ' :: COMPLETED');
}


foreach ($pushes as $push) {
    try {
        (new $push())->sync();
    } catch (Exception $e) {
        $app->logException($e);
    }

    $app->log($push . ' :: COMPLETED');
}

// Sync To Live DB

try {
    $app->changeServer(App::SERVER_TYPE_SERVER);
} catch (Exception $e) {
    $app->log($e->getMessage());
    $app->log('Connect To Server Database Failed');
    exit;
}

$pushes = ['MemberRewardUpdate'];

//$pushes = [];

foreach ($pushes as $push) {
    try {
        (new $push())->sync();
    } catch (Exception $e) {
        $app->logException($e);
    }

    $app->log($push . ' :: COMPLETED');
}


$app->logError('Sync Finished');