<?php


$url = "http://aanjaneyamushroomfarm.com/AccPos/";

$config_live = file_get_contents($url . 'version.json'.'?'.mt_rand());
$config_live = json_decode($config_live, true);

$config = file_get_contents('version.json');
$config = json_decode($config, true);

if($config_live['version'] <= $config['version']) {
	echo "No Updates Found...\r\n";
	exit;
}

$new_version = time();
$archive_name = 'updates/' . $config_live['file'];
$update_dir  = 'updates/update_' . $config_live['version'];
$backup_dir   = 'backup/update_' . $new_version;

echo "Downloading Update...\r\n";
$archive = file_get_contents($url . $config_live['file']);
if (!file_exists('updates')) {
	mkdir('updates');
}
file_put_contents($archive_name, $archive);
echo "Download Completed.\r\n";

$zip = new ZipArchive();
if (!$zip->open($archive_name, ZipArchive::CREATE))
{
	echo "Error Opening Zip File\r\n";
	exit;
}

echo "Extracting Archive...\r\n";

$zip->extractTo($update_dir);
$zip->close();

echo "Archive Extracted.\r\n";

echo "Updating...\r\n";

$files = getDirContents($update_dir);

mkdir($backup_dir, 0777, true);

$files = array_filter($files, function($file) use($update_dir, $backup_dir) {
	$rel_file = substr($file, strlen(__DIR__ . DIRECTORY_SEPARATOR . $update_dir));;
	$rel_file = str_replace(['/', '\\'], DIRECTORY_SEPARATOR, $rel_file);
	
	if (is_dir($file)) {
		if (!file_exists($backup_dir . $rel_file)) {
			mkdir($backup_dir . $rel_file, 0777, true);
		}
		return false;
	}
	
	return true;
});


foreach($files as $file) {
	$rel_file = substr($file, strlen(__DIR__ . DIRECTORY_SEPARATOR . $update_dir));;
	$rel_file = str_replace(['/', '\\'], DIRECTORY_SEPARATOR, $rel_file);
	
	copy(__DIR__ . $rel_file, $backup_dir . $rel_file);
	copy($update_dir . $rel_file, __DIR__ . $rel_file);
	
	echo __DIR__ . $rel_file . "\r\n";
}

echo "Saving Config...\r\n";

$config['version'] = $new_version;
file_put_contents('version.json', json_encode($config));

echo "Cleaning up...\r\n";

$it = new RecursiveDirectoryIterator($update_dir, RecursiveDirectoryIterator::SKIP_DOTS);
$files = new RecursiveIteratorIterator($it, RecursiveIteratorIterator::CHILD_FIRST);
foreach($files as $file) {
    if ($file->isDir()){
        rmdir($file->getRealPath());
    } else {
        unlink($file->getRealPath());
    }
}
rmdir($update_dir);
unlink($archive_name);

echo "Update Completed.\r\n";

function getDirContents($dir, &$results = array()){
    $files = scandir($dir);

    foreach($files as $key => $value){
        $path = realpath($dir.DIRECTORY_SEPARATOR.$value);
        if(!is_dir($path)) {
            $results[] = $path;
        } else if($value != "." && $value != "..") {
            getDirContents($path, $results);
            $results[] = $path;
        }
    }

    return $results;
}
